# Asterisk Project : Asterisk 13 Configuration_res_xmpp

Created by wikibot on Aug 08, 2014

# XMPP Messaging

This configuration documentation is for functionality provided by `res_xmpp`.

## xmpp.conf

### global

Global configuration settings

#### Configuration Option Reference

Option Name | Type | Default Value | Regular Expression | Description
--- | --- | --- | --- | ---
`debug` | `Custom` | `no` | `false` | Enable/disable XMPP message debugging
`autoprune` | `Custom` | `no` | `false` | Auto-remove users from buddy list.
`autoregister` | `Custom` | `yes` | `false` | Auto-register users from buddy list
`collection_nodes` | `Custom` | `no` | `false` | Enable support for XEP-0248 for use with distributed device state
`pubsub_autocreate` | `Custom` | `no` | `false` | Whether or not the PubSub server supports/is using auto-create for nodes
`auth_policy` | `Custom` | `accept` | `false` | Whether to automatically accept or deny users' subscription requests

#### Configuration Option Descriptions

##### autoprune

Auto-remove users from buddy list. Depending on the setup (e.g., using your personal Gtalk account for a test) this could cause loss of the contact list.

### client

Configuration options for an XMPP client

#### Configuration Option Reference

Option Name | Type | Default Value | Regular Expression | Description
--- | --- | --- | --- | ---
`username` | `String` |  | `false` | XMPP username with optional resource
`secret` | `String` |  | `false` | XMPP password
`serverhost` | `String` |  | `false` | Route to server, e.g. talk.google.com
`statusmessage` | `String` | `Online and Available` | `false` | Custom status message
`pubsub_node` | `String` |  | `false` | Node for publishing events via PubSub
`context` | `String` | `default` | `false` | Dialplan context to send incoming messages to
`priority` | `Unsigned Integer` | `1` | `false` | XMPP resource priority
`port` | `Unsigned Integer` | `5222` | `false` | XMPP server port
`timeout` | `Unsigned Integer` | `5` | `false` | Timeout in seconds to hold incoming messages
`debug` | `Custom` | `no` | `false` | Enable debugging
`type` | `Custom` | `client` | `false` | Connection is either a client or a component
`distribute_events` | `Custom` | `no` | `false` | Whether or not to distribute events using this connection
`usetls` | `Custom` | `yes` | `false` | Whether to use TLS for the connection or not
`usesasl` | `Custom` | `yes` | `false` | Whether to use SASL for the connection or not
`forceoldssl` | `Custom` | `no` | `false` | Force the use of old-style SSL for the connection
`keepalive` | `Custom` | `yes` | `false` | If enabled, periodically send an XMPP message from this client with an empty message
`autoprune` | `Custom` | `no` | `false` | Auto-remove users from buddy list.
`autoregister` | `Custom` | `yes` | `false` | Auto-register users bfrom buddy list
`auth_policy` | `Custom` | `accept` | `false` | Whether to automatically accept or deny users' subscription requests
`sendtodialplan` | `Custom` | `no` | `false` | Send incoming messages into the dialplan
`status` | `Custom` | `available` | `false` | Default XMPP status for the client
`buddy` | `Custom` |  | `false` | Manual addition of buddy to list

#### Configuration Option Descriptions

##### timeout

Timeout (in seconds) on the message stack. Messages stored longer than this value will be deleted by Asterisk. This option applies to incoming messages only which are intended to be processed by the `JABBER_RECEIVE` dialplan function.

##### autoprune

Auto-remove users from buddy list. Depending on the setup (e.g., using your personal Gtalk account for a test) this could cause loss of the contact list.

##### status

Can be one of the following XMPP statuses:

- `chat`
- `available`
- `away`
- `xaway`
- `dnd`

##### buddy

Manual addition of buddy to the buddy list. For distributed events, these budies are automatically added in the whitelist as 'owners' of the node(s).

### Import Version

This documentation was imported from Asterisk Version SVN-branch-13-r420538